variables:
  GIT_STRATEGY: clone

default:
  image: ekinoxio/build-image:af6df618
  before_script:
    - make setup-cicd-test-stage

stages:
  - test
  - bump-version
  - deploy

unit-tests:
  stage: test
  script:
    - make unit-test
  except:
    refs:
      - tags

lint-test:
  stage: test
  allow_failure: true
  script:
    - make lint
  except:
    refs:
      - tags

types-test:
  stage: test
  allow_failure: true
  script:
    - make types
  except:
    refs:
      - tags

format-test:
  stage: test
  allow_failure: true
  script:
    - make format-check
  except:
    refs:
      - tags

bump-version:
  stage: bump-version
  when: manual
  only:
    - master
  script:
    - make bump-version
  parallel:
    matrix:
      - BUMP_TYPE: [ major, minor, patch ]

pages:
  stage: deploy
  only:
    refs:
      - tags
  script:
    - pip install mkdocs-material
    - mkdocs build --site-dir public
  artifacts:
    paths:
      - public

